<?php


function akismet_check_spam($message){

    global $PHORUM;
    
    if(!$PHORUM["user"]["admin"] && 
        !$message["moderator_post"] &&
            ($PHORUM["user_id"]==0 || 
                ($PHORUM["akismet"]["check_reg"] && 
                    ($PHORUM["akismet"]["min_posts"]==0 || 
                        $PHORUM["akismet"]["min_posts"] > $PHORUM["user"]["post_count"])))){

        $return = akismet_http_request( $message, "comment-check" );
        
        if($return=="true"){
            $message["status"] = PHORUM_STATUS_HOLD;
        }
    }
    
    return $message;
}

function akismet_moderation($mod_step){

    switch($mod_step){

        case PHORUM_DELETE_MESSAGE:
        case PHORUM_DELETE_TREE:
            $message =phorum_db_get_message($GLOBALS["msgthd_id"]);
            $return = akismet_http_request( $message, "submit-spam" );
            break;
    
        case PHORUM_APPROVE_MESSAGE:
        case PHORUM_APPROVE_MESSAGE_TREE:
            $message =phorum_db_get_message($GLOBALS["msgthd_id"]);
            $return = akismet_http_request( $message, "submit-ham" );
            break;
    }
    
}

function akismet_read_url_change($messages) {

    global $PHORUM;

    if($PHORUM["DATA"]["MODERATOR"]){
        foreach($messages as $key=>$message){

            $message["spam_url1"] = phorum_get_url(PHORUM_MODERATION_URL, PHORUM_DELETE_MESSAGE, $message["message_id"], "spam=1");
            $message["spam_url2"] = phorum_get_url(PHORUM_MODERATION_URL, PHORUM_DELETE_TREE, $message["message_id"], "spam=1");

            $messages[$key] = $message;

        }
    }
    return $messages;
}

function akismet_verify_key($key){
    return akismet_http_request( $key, "verify-key" );
}

function akismet_http_request( $message, $mode ) {

    global $PHORUM;

    if($mode == "verify-key"){
        $host = "rest.akismet.com";

        $data = "key=".urlencode($message)."&blog=".urlencode($PHORUM["http_path"]);

    } else {

        $host = $PHORUM["akismet"]["key"].".rest.akismet.com";
    
        $data = "blog=".urlencode($PHORUM["http_path"]);
        $data.= "&user_ip=".urlencode($_SERVER["REMOTE_ADDR"]);
        $data.= "&user_agent=".urlencode($_SERVER["HTTP_USER_AGENT"]);
        $data.= "&referrer=".urlencode($_SERVER["HTTP_REFERER"]);
        if($message["thread"]){
            $data.= "&permalink=".urlencode(phorum_get_url(PHORUM_FOREIGN_READ_URL, $message["forum_id"], $message["thread"]));
        } else {
            $data.= "&permalink=".urlencode(phorum_get_url(PHORUM_LIST_URL, $message["forum_id"]));
        }
        $data.= "&comment_type=".urlencode("forum");
        $data.= "&comment_author=".urlencode($message["author"]);
        $data.= "&comment_author_email=".urlencode($message["email"]);
        $data.= "&comment_content=".urlencode($message["body"]);
    }

    $fp = @fsockopen( $host, 80, $errno, $errstr, 8 );

    if($fp){
        stream_set_timeout ( $fp, 10 );

        fputs( $fp, "POST /1.1/$mode HTTP/1.0\n" );
        fputs( $fp, "Host: $host\n" );
        fputs( $fp, "Content-type: application/x-www-form-urlencoded\n" );
        fputs( $fp, "Content-length: " . strlen( $data ) . "\n" );
        fputs( $fp, "User-Agent: Phorum ".PHORUM."\n" );
        fputs( $fp, "Connection: close\n\n" );
        fputs( $fp, $data );

        $x=1;
        while ( !feof( $fp ) ) {
            $buf .= fgets( $fp, 1024 );

            // if the fgets returns nothing on the first return,
            // the remote server is timing out.
            if($x==1 && $buf==""){
                $errstr="timeout waiting for data";
                break;
            }
            $x++;
        }

        fclose( $fp );

    }

    if(!$fp || empty($buf)){
        trigger_error("Could not open $host: $errstr", E_USER_WARNING);
    }

    $buf = str_replace( "\r", "", $buf ); //strip out carriage returns
    list( $page_data["headers"], $page_data["content"] ) = explode( "\n\n", $buf, 2 );

    return $page_data["content"];
}


?>
